#include "Test.h"

int main()
{
	//     .
	DWORD (*GetProcessID) (const wchar_t *Title);
	DWORD (*GetHStartPoint) (const HANDLE hProcess, const BYTE Version);
	int (*RAMHero) (const HANDLE hProcess, const DWORD HStartPoint, const BYTE ID, void *HeroRecord);
	int (*RAMWeights) (const HANDLE hProcess, const DWORD HStartPoint, const BYTE Version, const BYTE Class, void *WeightsRecord);
	int (*LevelUp) (void *HeroRecord, const void *WeightsRecord, void *SkillOfferRecord, const BYTE Option, const BYTE SlotCount);
	
	//     " " ("Birth of a Barbarian").
	bool (*isStandardWeights) (const HANDLE hProcess, const DWORD HStartPoint, const BYTE Version, const BYTE ID);
	int (*RAMBBWeights) (const HANDLE hProcess, const DWORD HStartPoint, const BYTE Version, const BYTE Class, void *WeightsRecord);

	//      .
	HINSTANCE hDLL = LoadLibrary(L"LMOracle.SkillTreeAPI.dll");
	if ( !hDLL ) return -1;

	GetProcessID = (DWORD (*) (const wchar_t *)) GetProcAddress(hDLL, "GetProcessID");
	GetHStartPoint = (DWORD (*) (const HANDLE, const BYTE)) GetProcAddress(hDLL, "GetHStartPoint");
	RAMHero = (int (*) (const HANDLE, const DWORD, const BYTE, void *)) GetProcAddress(hDLL, "RAMHero");
	RAMWeights = (int (*) (const HANDLE, const DWORD, const BYTE, const BYTE, void *)) GetProcAddress(hDLL, "RAMWeights");
	LevelUp = (int (*) (void *, const void *, void *, const BYTE, const BYTE)) GetProcAddress(hDLL, "LevelUp");
	isStandardWeights = (bool (*) (const HANDLE, const DWORD, const BYTE, const BYTE)) GetProcAddress(hDLL, "isStandardWeights");
	RAMBBWeights = (int (*) (const HANDLE, const DWORD, const BYTE, const BYTE, void *)) GetProcAddress(hDLL, "RAMBBWeights");

	//  PID     .
	DWORD ProcessID = GetProcessID(L"    III");
	HANDLE hProcess = OpenProcess(PROCESS_VM_READ, false, ProcessID);

	//     ,     : GetHStartPoint(< >, < >), 
	// < > = 0  4.0 RU, 
	// < > = 1  4.0 EN,
	// < > = 2  3.2 EN,
	// < > = 3  Heroes Chronicles 1.0 RU.
	DWORD HStartPoint = GetHStartPoint(hProcess, 0);

	//    THero, TWeights  TSkillOffer. 
	THero Hero;
	TWeights Weights;
	TSkillOffer SkillOffer;
	
	//    ID    MaxLevel,     .
	int ID, MaxLevel, Slot;
	cout << "Enter ID and MaxLevel: ";
	cin >> ID >> MaxLevel;
	cout << endl;

	//        ID.
	RAMHero(hProcess, HStartPoint, ID, &Hero);
	
	//        ,     Hero,
	//        " " ("Birth of a Barbarian").
	//     BBFlag,    0     4 -  
	BYTE BBFlag = isStandardWeights(hProcess, HStartPoint, 0, ID) ? 0 : 4; 
	BBFlag ? RAMBBWeights(hProcess, HStartPoint, 0, Hero.Class, &Weights) : RAMWeights(hProcess, HStartPoint, 0, Hero.Class, &Weights);
	
	// 
	for (int i = 0; i < MaxLevel; ++i)
	{
		// Option = 000b = 0 -  SkillOffer,     Hero;
		// Option = 001b = 1 -  SkillOffer     Hero,     ;
		// Option = 010b = 2 -  SkillOffer     Hero,     ;
		// Option = 1xxb -  SkillOffer c    " " ("Birth of a Barbarian"),
		//  xx = 00, 01  10 (. ).
		
		// .
		// Option = 110b = 6 -  SkillOffer c    " " ("Birth of a Barbarian")
		//     Hero,     .
		LevelUp(&Hero, &Weights, &SkillOffer, BBFlag, 8); // Option = 000b OR BBFlag

		//      
		cout << "SkillOffer = [" << PrimSkillName[SkillOffer.Primary] << ", ["
			 << SecSkillName[SkillOffer.Secondary.Left] << ", " << SecSkillName[SkillOffer.Secondary.Right] << "]]"
			 << endl << endl;

		//  : 1 - , 2 - 
		cout << "Slot = ";
		cin >> Slot;
		cout << endl;

		LevelUp(&Hero, &Weights, &SkillOffer, Slot | BBFlag, 8); // Option = Slot OR BBFlag
		
		//     .
		cout << "Level = " << (int)Hero.Level << endl
			 << "LastWisdom = " << (int)Hero.LastWisdom << endl
			 << "LastMagic = " << (int)Hero.LastMagic << endl 
			 << "Primary = " << (int)Hero.Attack << " " << (int)Hero.Defense
			 << " " << (int)Hero.SpellPower << " " << (int)Hero.Knowledge
			 << endl << endl;
			 
		cout << "SkillCount = " << (int)Hero.SkillCount << endl << "Secondary = ";
		for (int i = PATHFINDING; i < NONE; ++i) cout << (int)Hero.Skill[i] << " ";
		cout << endl << endl;
		
		system("Pause");
		cout << endl;
	}	
		
	//  ,    .
	CloseHandle(hProcess);
	FreeLibrary(hDLL);
	
	return 0;
}