#include <iostream>
#include <windows.h>

using namespace std;

struct THero
{
	BYTE Class;
	BYTE Level;
	BYTE TreeNumber;
	BYTE LastWisdom;
	BYTE LastMagic;
	BYTE Attack;
	BYTE Defense;
	BYTE SpellPower;
	BYTE Knowledge;
	BYTE SkillCount;
	BYTE Skill[28];
};

struct TWeights
{
	BYTE PW[4];
	BYTE PW10[4];
	BYTE SW[28];
	bool SR[28];
};

struct TSecondary
{
	BYTE Left;
	BYTE Right;
};

struct TSkillOffer
{
	BYTE Primary;
	TSecondary Secondary;
};

enum {ATTACK, DEFENSE, SPELL_POWER, KNOWLEDGE};

enum
{
	PATHFINDING, ARCHERY, LOGISTICS, SCOUTING, DIPLOMACY, NAVIGATION, LEADERSHIP,
	WISDOM, MYSTICISM, LUCK, BALLISTICS, EAGLE_EYE, NECROMANCY, ESTATES,
	FIRE_MAGIC, AIR_MAGIC, WATER_MAGIC, EARTH_MAGIC, SCHOLAR, TACTICS, ARTILLERY,
	LEARNING, OFFENSE, ARMORER, INTELLIGENCE, SORCERY, RESISTANCE, FIRST_AID, NONE 
};

const char *PrimSkillName[4] = {"ATTACK", "DEFENSE", "SPELL_POWER", "KNOWLEDGE"};

const char *SecSkillName[29] =
{
	"PATHFINDING", "ARCHERY", "LOGISTICS", "SCOUTING", "DIPLOMACY", "NAVIGATION", "LEADERSHIP",
	"WISDOM", "MYSTICISM", "LUCK", "BALLISTICS", "EAGLE_EYE", "NECROMANCY", "ESTATES",
	"FIRE_MAGIC", "AIR_MAGIC", "WATER_MAGIC", "EARTH_MAGIC", "SCHOLAR", "TACTICS", "ARTILLERY",
	"LEARNING", "OFFENSE", "ARMORER", "INTELLIGENCE", "SORCERY", "RESISTANCE", "FIRST_AID", "NONE" 
};